/**
 *	count frequency of characters in a file	- countfreq.cpp
 */
#include "symbol.h"
#include <fstream>
#include <iostream>
using namespace std;

// max length of file name 
const unsigned int FileNameLen = 20;

// no. of ascii char 
const unsigned int AsciiSize = 256;

/**
 *	count frequency of each character in a text file
 *		@param	- file name
 */
void countfreq(const char* itxtfile) {

	Symbol	symtbl[AsciiSize];

	for (unsigned int i=0;i<AsciiSize;i++) 
		symtbl[i] = Symbol(char(i));

	ifstream infile(itxtfile);
	char ch;
	unsigned int fcnt = 0;	// count file size

	infile.get(ch);
	while (!infile.eof()) {
		fcnt++;
		++symtbl[unsigned int(ch)];
		infile.get(ch);
	}
	infile.close();

	cout << "\nInput file size : " << fcnt << endl;
	
	for (unsigned int i=0;i<AsciiSize;i++) 
		if (symtbl[i].Freq() > 0) 
			cout << symtbl[i] << endl;

	

}

int main()
{
	char	itxtfile[FileNameLen];

	cin >> itxtfile;
	countfreq(itxtfile);

	return 0;
}
