/**
 *	class Pix		pix.h
 *
 *			date	:	13dec2004
 *			author	:	FYMong
 *			purpose	:	abstraction - a symbol to be displayed on console screen
 */
#ifndef consoleAPI_pix
#define consoleAPI_pix
#include <iostream>
using namespace std;

class Screen;

class Pix
{
	public :
		/**
		 *	color values
		 */
		enum Color { Default, Red, iRed, Green, iGreen, Blue, iBlue, Yellow, iYellow, Cyan, iCyan, Magenta, iMagenta, White, iWhite, Black, iBlack, consoleColorTotal};
		/**
		 *	box border
		 */
		enum BoxBorder { SlimBox, Box, ThickBox, TotBox };
		/**
		 *	color code length
		 */
		enum { consoleColorlen = 9 };
		/**
		 *	default constructor
		 *		@param	- symbol,color of symbol, background color
		 */
		Pix(char sym=' ',Color scolor=Black,Color bcolor=Black);
		/**
		 *	copy constructor
		 */
		Pix(const Pix& pix);
		/**
		 *	destructor
		 */
		virtual ~Pix();
		/**
		 *	overload =
		 */
		virtual Pix& operator =(const Pix& pix);
		/**
		 *	overload ==
		 */
		virtual bool operator ==(const Pix& pix) const;
		/**
		 *	debug display
		 */
		friend ostream& operator <<(ostream& os, const Pix& pix);
		/**
		 *	static member color code
		 */
		static char consoleAPIcolors[consoleColorTotal][consoleColorlen];
	private :
		/**
		 *	symbol
		 */
		char symbol;
		/**
		 *	symbol color
		 */
		Color color;
		/**
		 *	background color
		 */
		Color bgcolor;
		/**
		 *	friend class Screen
		 */
		friend class Screen;

};

#endif
