/**
 *	class Point		- point.h
 *
 *			date	:	13dec2004
 *			author	:	FYMong
 *			purpose	:	abstraction - location on screen
 */
#ifndef ConsoleAPI_Point
#define ConsoleAPI_Point
#include <iostream>
using namespace std;


class Screen;

class Point {
	private :
		/**
		 *	row no.
		 */
		unsigned int row;
		/**
		 *	col no.
		 */
		unsigned int col;
		friend class Screen;
	public :
		/**
		 *	default constructor
		 *		@param	- row=col=0
		 */
		Point(unsigned int r=0,unsigned int c=0); 
		/**
		 *	copy constructor
		 *		@param	- Point
		 */
		Point(const Point& point);
		/**
		 *	destructor
		 */
		virtual ~Point();
		/**
		 *	show on screen
		 *		@param	- screen, color
		 */
//		void Show(cConsole cscr,Color color) const;
		/**
		 *	hide on screen
		 *		@param	- screen, color
		 */
//		void Hide(cConsole cscr, Color color) const;
		/**
		 *	overload =
		 */
		Point& operator =(const Point& point);
		/**
		 *	overload ==
		 */
		virtual bool operator ==(const Point& point) const;
		/**
		 *	overload !=
		 */
		virtual bool operator !=(const Point& point) const;
		/**
		 *	overload +
		 *		@param	- point
		 *		return	- Point
		 */
		virtual Point operator +(const Point& point) const;
		/**
		 *	overload -
		 *		@param	- point
		 *		return	- Point	(-ve result ignored)
		 */
		virtual Point operator -(const Point& point) const;
		/**
		 *	overload %
		 *		@param	- point
		 *		return	- Point	(-ve result ignored)
		 */
		virtual Point operator %(const Point& point) const;
		/**
		 *	isAbove
		 *		@param	- point
		 *		return	- true/false
		 */
		virtual bool isAbove(const Point& point) const;
		/**
		 *	isBelow
		 *		@param	- point
		 *		return	- true/false
		 */
		virtual bool isBelow(const Point& point) const;
		/**
		 *	isLeftof
		 *		@param	- point
		 *		return	- true/false
		 */
		virtual bool isLeftof(const Point& point) const;
		/**
		 *	isRightof
		 *		@param	- point
		 *		return	- true/false
		 */
		virtual bool isRightof(const Point& point) const;
		/**
		 *	debug display
		 */
		friend ostream& operator <<(ostream& os,const Point& point);
		/**
		 *	overload >>
		 */
		friend istream& operator >>(istream& is, Point& point);
};

#endif