/**
 *	class Symbol function definition	- symbol.cpp
 */
#include "symbol.h"
#include <string>
#include <iomanip>
using namespace std;

/**
 *	default constructor
 */
Symbol::Symbol(): alpha(NULL) {}

/**
 *	constructor
 */
Symbol::Symbol(char alp): alpha(alp) {}

/**
 *	copy constructor
 */
Symbol::Symbol(const Symbol& symbol) {	
	alpha = symbol.alpha;
	frequency = symbol.frequency;
}

/**
 *	overload =
 */
Symbol& Symbol::operator = (const Symbol& symbol) {	// 
	alpha = symbol.alpha;
	frequency = symbol.frequency;
	return (*this);
}

/**
 *	overload ==
 */
bool Symbol::operator ==(const Symbol& symbol) const { // 
	return (alpha==symbol.alpha);
}
/**
 *	overload !=
 */
bool Symbol::operator !=(const Symbol& symbol) const { 
		return (alpha != symbol.alpha);
	}
/**
 *	overload <
 */
bool Symbol::operator < (const Symbol& symbol) const { 

	return (alpha < symbol.alpha);
}
/**
 *	overload >
 */
bool Symbol::operator > (const Symbol& symbol) const {

	return !(*this < symbol || *this == symbol);
}
/**
 *	overload ++ prefix
 */
Symbol& Symbol::operator ++ () {

	frequency++;
	return *this;
}
/**
 *	overload <<
 */
ostream& operator <<(ostream& os,const Symbol& symbol) {	// overload output

	os << " [" << symbol.alpha << "," << setw(5) << symbol.frequency << "]";
	return os;
}
/**
 *	get character
 */
char Symbol::Alpha() const {

	return alpha;
}
/**
 *	get frequency
 */
unsigned int Symbol::Freq() {
	return frequency;
}
