// Class to represent the symbols and frequency	- symbol.h
#ifndef symbol_h
#define symbol_h
#include <iostream>
using namespace std;

// represent each Symbol
class Symbol 
{
	public :
		/**
		 *	default constructor
		 */
		Symbol();
		/**
		 *	constructor
		 */
		Symbol(char alp);
		/**
		 *	copy constructor
		 */
		Symbol(const Symbol& symbol);
		/** 
		 *	overload =
		 */
		Symbol& operator = (const Symbol& symbol);
		/**
		 *	overload ==
		 */
		bool operator ==(const Symbol& symbol) const;
		/**
		 *	overload !=
		 */
		bool operator !=(const Symbol& symbol) const;
		/**
		 *	overload <
		 */
		bool operator < (const Symbol& symbol) const;
		/**
		 *	overload >
		 */
		bool operator > (const Symbol& symbol) const;
		/**
		 *	overload ++ prefix
		 */
		Symbol& operator ++ ();

		/**
		 *	overload <<
		 */
		friend ostream& operator <<(ostream& os,const Symbol& symbol);
		/**
		 *	get character
		 */
		char Alpha() const;
		/**
		 *	get frequency
		 */
		unsigned int Freq();
	private :
		char	alpha;	// a single characters
		unsigned int frequency;	// frequency the string
};


#endif

