/**
 *	Test class ConsoleAPI	- testconsoleAPI.cpp
 */
#include "consoleAPI.h"
//#include "pix.h"
//#include "point.h"
#include <iostream>
#include <string>
using namespace std;

//	screen size
const unsigned int MaxRow = 55;
const unsigned int MaxCol = 100;

//	screen 1 setup : pos + size
const Point scr1ULC = Point(5,10);
const unsigned int scr1Height = 5;
const unsigned int scr1Width = 10;

//	screen 2 setup : pos + size 
const Point scr2ULC = Point(17,5);
const unsigned int scr2Height = 35;
const unsigned int scr2Width = 65;

//	screen 3 setup : pos + size	- on top of screen 2
const Point scr3ULC = Point(5,40);
const unsigned int scr3Height = 10;
const unsigned int scr3Width = 10;

//	screen 4 setup	: pos + size	= on top of screen 2
const Point scr4ULC = Point(20,40);
const unsigned int scr4Height = 10;
const unsigned int scr4Width = 20;

//	screen 5 setup
const Point scr5ULC = Point(20,10);
const unsigned int scr5Height = 10;
const unsigned int scr5Width = 10;

//	set cursor
const Point curPos = Point(48,1);
const Pix curPix = Pix(' ',Pix::iWhite);

void consoletest1() {

	ConsoleAPI*	myAPI = new ConsoleAPI(MaxRow,MaxCol);
	string	cs2332 = "cs2332 project 2005-06B";

	myAPI->setTitle(cs2332);

	//	screen 1	: user-defined border
	Pix scr1bd('*',Pix::iBlue);
	unsigned int scr1 = myAPI->newSubScreen(scr1ULC,scr1Height,scr1Width);
	if (scr1 > 0)
		myAPI->setSubScreen(scr1,scr1bd);

	//	screen 2	: user-defined border, background
	Pix scr2bd('^',Pix::iCyan,Pix::iWhite);
	unsigned int scr2 = myAPI->newSubScreen(scr2ULC,scr2Height,scr2Width);
	if (scr2 > 0)
		myAPI->setSubScreen(scr2,scr2bd,Pix::Magenta);

	//	screen 3	: thick box border
	Pix scr3bd(' ',Pix::iCyan,Pix::iWhite);
	unsigned int scr3 = myAPI->newSubScreen(scr3ULC,scr3Height,scr3Width);
	if (scr3 > 0)
		myAPI->setSubScreenBox(scr3,Pix::ThickBox,scr3bd,Pix::iWhite);
	//	position of string is relative to the screen scr3
	bool ok = myAPI->PostCStr(Point(1,2),"test3",scr3,Pix::Cyan,Pix::iWhite);

	//	screen 4	: box 
	Pix scr4bd(' ',Pix::iBlue,Pix::Magenta);
	unsigned int scr4 = myAPI->newSubScreen(scr4ULC,scr4Height,scr4Width);
	if (scr4 > 0)
		myAPI->setSubScreenBox(scr4,Pix::Box,scr4bd,Pix::iYellow);
	myAPI->PostCStr(Point(1,1),"test4",scr4,Pix::iCyan,Pix::Red);
	myAPI->PostCStr(Point(5,1),"chartest",scr4,Pix::iCyan,Pix::Red);
	
	//	screen 5	: slim box border
	Pix scr5bd(' ',Pix::iRed,Pix::Magenta);
	unsigned int scr5 = myAPI->newSubScreen(scr5ULC,scr5Height,scr5Width);
	if (scr5 > 0)
		myAPI->setSubScreenBox(scr5,Pix::SlimBox,scr5bd,Pix::iGreen);
	myAPI->PostCStr(Point(2,2),"test5",scr5,Pix::iRed,Pix::iWhite);

	myAPI->showPix(curPos,curPix);	// default screen
	myAPI->showCursor();
	myAPI->getKey();
	myAPI->clearScreen();
	delete myAPI;


}



int main()
{

	consoletest1();

	return 0;


}
