/**
 *	Test pointers		- pointer.cpp
 *
 *	exercise 1 : ptr_asg
 *		keep "intptr2	= intptr1;"; "delete intptr1;"; "delete intptr2;"
 *		- check intptr2 has been changed to value of intptr1
 *		- check memory of *intptr2 has same value as *intptr1
 *		result : pgm hung up due to deleting pointer twice
 *
 *	exercise 2 : ptr_asg, check_zombie
 *		keep "intptr2	= intptr1;"; "delete intptr1;"; 
 *		comment out "delete intptr2;"
 *		- check memory of *intptr2 not deallocated
 *		- step into check_zombie :
 *			- intptr1 of ptr_asg is re-used but not intptr2 of ptr_asg
 *		
 */
#include <iostream>
using namespace std;


// test pointer assignment
void ptr_asg() {

	int*	intptr1;
	int*	intptr2;

	intptr1	= new int(10);
	intptr2 = new int(15);
	intptr2	= intptr1;
	cout << *intptr2 << endl;
	delete intptr1;
	delete intptr2;

}

// see pointers not deleted
void check_zombie() {

	int*	intptr1;
	int*	intptr2;

	intptr1 = new int(100);
	intptr2 = new int(150);

	delete intptr1;
	delete intptr2;

}

int main()
{
	ptr_asg();

	check_zombie();

	return 0;
}
