/**
 *	Function definitions of class Object	- object.cpp
 */
#include "object.h"
#include <iostream>
using namespace std;
/**
 *	default constructor
 */
Object::Object(unsigned int s) { // default constructor

	name = "\0";
	size = s;
	iarray = new int [size];
	for (unsigned int i=0;i<size;i++)
		iarray[i] = 0;
}
/**
 *	destructor
 */
Object::~Object() {

	delete [] iarray;
}

/**
 *	overload +
 *		@param	-	obj
 *		return	-	Object
 */
Object Object::operator +(const Object& obj) const { // overload +

	Object tobj;
	tobj.name = name + obj.name;
	tobj.size = size;
	tobj.iarray = new int[size];
	for (unsigned int i=0;i<size;i++)
		tobj.iarray[i] = iarray[i] + obj.iarray[i];
	return tobj;
}
/**
 *	overload ++	:	pre-increment
 *		return	-	Object
 */
Object& Object::operator ++() { // overload prefix++, increment each element

	for (unsigned int i=0;i<size;i++)
		++iarray[i];
	return *this;
}
/**
 *	overload <<	-	friend
 *		@param	-	os, obj
 *		return	-	os
 */
ostream& operator <<(ostream& os,const Object& obj) { // overload <<
	
	os << obj.name << " ";
	for (unsigned int i=0;i<obj.size;i++)
		os << obj.iarray[i] << " ";

	return os;
}
/**
 *	overload >>	-	friend
 *		@param	-	is, obj
 *		return	-	is
 */
istream& operator >>(istream& is,Object& obj) { // overload <<

	is >> obj.name;
	for (unsigned int i=0;i<obj.size;i++)
		is >> obj.iarray[i];
	return is;
}


