/**
 *	class Object	- object.h
 */
#ifndef object_h
#define object_h
#include <iostream>
#include <string>
using namespace std;

/**
 *	class Object - test copy constructor
 */
class Object {	

	public :
		/**
		 *	default array size 
		 */
		enum { MaxLen = 5 };
		/**
		 *	default consstructor
		 */
		Object(unsigned int s=MaxLen);
		/**
		 *	destructor
		 */
		~Object();
		/**
		 *	overload +	- add two objects
		 *		@param	-	obj
		 *		return	-	Object
		 */
		Object operator +(const Object& obj) const;
		/**
		 *	overload ++ - pre-increment
		 *		return	-	Object
		 */
		Object& operator++();
		/**
		 *	overload <<	- friend
		 *		@param	-	os, obj
		 *		return	-	os
		 */
		friend ostream& operator <<(ostream& os,const Object& obj);
		/**
		 *	overload >>	- friend
		 *		@param	-	is, obj
		 *		return	-	is
		 */
		friend istream& operator >>(istream& is,Object& obj);
	private :
		/**
		 *	name
		 */
		string name;
		/**
		 *	size of array
		 */
		unsigned int size;
		/**
		 *	dynamic int array
		 */
		int* iarray;
};
#endif

