//
// *************** fill in here ***************
//
template <class DType> 
class BSTree;

// a tree node
template <class DType>
class TreeNode
{
	private :
		DType key;
		TreeNode *left,*right;
	public :
		TreeNode() : left(NULL), right(NULL) {}
		TreeNode(const DType&  k): left(NULL),right(NULL),key(k) {}
		friend class BSTree<DType>;
};

// a binary search tree
template <class DType>
class BSTree
{
	public :
		/**
		 *	constructor
		 */
		BSTree():root(NULL), found(NULL) {}
		/**
		 *	copy constructor
		 */
		BSTree(const BSTree& bstree);
		/**
		 *	overload =
		 */
		BSTree& operator =(const BSTree& bstree);
		/**
		 *	destructor
		 */
		~BSTree();
		/**
		 *	search key
		 */
		bool Search(const DType& k);
		/**
		 *	insert key
		 */
		bool Insert(const DType& k);
		/**
		 *	delete key
		 */
		bool DeleteKey(const DType& k) ;
		/**
		 *	minimum in found
		 */
		bool Minimum();
		/**
		 *	maximum in found
		 */
		bool Maximum();
		/**
		 *	height of tree
		 */
		int Height() const;
		/**
		 *	inorder traversal
		 */
		void Inorder() const;
		/**
		 *	preorder traversal
		 */
		void Preorder() const;
		/**
		 *	postorder traversal
		 */
		void Postorder() const;
		/**
		 *	return key in found
		 */
		DType KeyFound() const;
		/**
		 *	display tree
		 */
		friend ostream& operator <<(ostream& os, const BSTree<DType>& bstree);

	protected :
		/**
		 *	recursive functions 
		 *
		 *	fill in here
		 *	
		 */

	private :
		/**
		 *	root of tree
		 */
		TreeNode<DType> *root;
		/**
		 *	point to node found
		 */
		TreeNode<DType> *found;	
};


#include "bstreecpp.h"

